# Contributing to OB-UDPST

**First:** If you're unsure or afraid of _anything_, just ask or submit the issue anyways. You won't be yelled at for giving your best effort.  The worst that can happen is that you'll be politely asked to change something. We appreciate any sort of contributions, and don't want a wall of rules to get in the way of that.

## Getting Started
### Some Ways to Contribute
* Report potential bugs.
* Improve our README or the output messaging of the software.
* Respond to questions about usage on the issue tracker or mailing list.

### Reporting an Issue:
>Note: Issues on GitHub for OB-UDPST are intended to be related to bugs and integration questions. 

* Make sure you test against the latest released version. It is possible we already fixed the bug you're experiencing. However, if you are on an older version and feel the issue is critical, do let us know.

* Check existing issues (both open and closed) to make sure it has not been reported previously.

* Provide a reproducible test case. If a contributor can't reproduce an issue, then it dramatically lowers the chances it'll get fixed.

* Aim to respond promptly to any questions made by the OB-UDPST team on your issue. Stale issues will be closed.

## Building OB-UDPST

For any build considerations, please refer to the README.

## Contributor License Agreement

Any company or individual interested in participating in this open source project must sign a Contributor License Agreement (more details [here](https://wiki.broadband-forum.org/pages/viewpage.action?pageId=87557395)).

Download the Agreement from here: [OB-UDPST Project CLA](https://wiki.broadband-forum.org/pages/viewpage.action?pageId=95945137)
